/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor;

/**
 *
 * @author jimj316
 */
public enum ClassMethodType
{
    /**
     * takes no input, makes no changes, returns a value
     * Should be added to an object node, given a constant port
     */
    GETTER,
    SETTER, // takes one input, changes one field, returns nothing
    ADDER, // takes one input, makes other state changes, returns nothing
    TAKER, // takes no input, makes other state changes, returns a value
    CALLBACK, // takes a single argument of an abstract class
    ACTION, // takes no input or output

    TRANSFORMER, // takes input, changes the object, then returns the object (eg. builder methods)
    FUNCTION, // takes one or more unrelated types, and returns a result
    CONSTANT, // static; no input, returns a value
    FACTORY,
    OTHER,
}
